<?php

namespace Siropu\AdsManager\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class GroupDiscount extends Entity
{
     public static function getStructure(Structure $structure)
	{
          $structure->table      = 'xf_siropu_ads_manager_group_discount';
          $structure->shortName  = 'AdsManager:GroupDiscount';
          $structure->primaryKey = 'group_discount_id';

          $structure->columns = [
               'group_discount_id' => ['type' => self::UINT, 'autoIncrement' => true],
               'title'             => ['type' => self::STR, 'maxLength' => 100, 'required' => 'please_enter_valid_title'],
               'user_groups'       => ['type' => self::JSON_ARRAY, 'default' => []],
               'packages'          => ['type' => self::JSON_ARRAY, 'default' => []],
               'discount'          => ['type' => self::JSON_ARRAY, 'default' => []],
               'enabled'           => ['type' => self::UINT, 'default' => 1]
          ];

          return $structure;
     }
     protected function verifyDiscount(&$discount)
     {
          if (isset($discount['purchase'], $discount['discount']))
          {
               $discount = array_filter(array_combine($discount['purchase'], array_map('floatval', $discount['discount'])));
          }

          return true;
     }
     public function getDiscountSorted()
     {
          $discount = $this->discount;
          ksort($discount);

          return $discount;
     }
}
