<?php

namespace Siropu\AdsManager\Job;

use XF\Job\AbstractRebuildJob;

class SetPurchaseRequestKey extends AbstractRebuildJob
{
	protected function getNextIds($start, $batch)
	{
		$db = $this->app->db();

		return $db->fetchAllColumn($db->limit(
			"
				SELECT purchase_request_id
				FROM xf_purchase_request
                    WHERE purchasable_type_id = 'advertising'
				AND purchase_request_id > ?
                    ORDER BY purchase_request_id
			", $batch
		), $start);
	}
     protected function rebuildById($id)
	{
          /** @var \XF\Entity\PurchaseRequest $purchaseRequest */
		$purchaseRequest = $this->app->em()->find('XF:PurchaseRequest', $id);

          $extraData = $purchaseRequest->extra_data;

		/** @var \Siropu\AdsManager\Entity\Invoice $invoice */
		$invoice = $this->app->em()->find('Siropu\AdsManager:Invoice', $extraData['invoice_id'] ?? 0);

		if ($invoice && !$invoice->purchase_request_key)
		{
			$invoice->fastUpdate('purchase_request_key', $purchaseRequest->request_key);
		}
     }
	protected function getStatusType()
	{
		return \XF::phrase('siropu_ads_manager_set_invoice_purchase_request_key');
	}
}
