<?php

namespace Siropu\AdsManager\Option;

use XF\Option\AbstractOption;
use XF\Util\File;

class AdsTxt extends AbstractOption
{
     public static function renderOption(\XF\Entity\Option $option, array $htmlParams)
	{
          $adsTxt = self::getFile();

          if (file_exists($adsTxt))
          {
               $option->option_value = file_get_contents($adsTxt);
          }

          return self::getTemplate('admin:siropu_ads_manager_option_template_adsTxt', $option, $htmlParams);
	}
     public static function verifyOption(&$value, \XF\Entity\Option $option)
	{
          $adsTxt = self::getFile();

          if ($value)
          {
               $written = File::writeFile($adsTxt, $value, false);

               if (!$written)
               {
                    $option->error('Could not write ads.txt file.', $option->option_id);
                    return false;
               }
          }
          else if (file_exists($adsTxt))
          {
               @unlink($adsTxt);
          }

		return true;
	}
     protected static function getFile()
     {
          return realpath($_SERVER['DOCUMENT_ROOT']) . '/ads.txt';
     }
}
